User system registration

Updated

Agora Chat RESTful APIs for user system registration and management.

This page shows how to call Chat RESTful APIs to create and manage the user system, including how to register, modify, delete, ban, and unban a user, get user information, and force a user to log out.

Before calling the following methods, make sure you understand the call frequency limit of the Chat RESTful APIs as described in Limitations.

Common parameters

The following table lists common request and response parameters of the Chat RESTful APIs:

Request parameters

ParameterTypeDescriptionRequired
hostStringThe domain name assigned by the Chat service to access RESTful APIs. For how to get the domain name, see Get the information of your project.Yes
app_idStringThe unique identifier automatically assigned to each project by AgoraYes
usernameString

The unique login account of the user. The user ID must be 64 characters or less and cannot be empty. The following character sets are supported:

  • 26 lowercase English letters (a-z)
  • 10 numbers (0-9)
  • "_", "-", "."

Do not use any of the 26 uppercase English letters (A-Z). Ensure that each username under the same App ID is unique. Do not set this parameter as a UUID, email address, phone number, or other sensitive information.

Yes

Response parameters

ParameterTypeDescription
actionStringThe request method.
organizationStringThe unique identifier assigned to each company (organization) by the Chat service.
applicationStringA unique internal ID assigned to each app by the Chat service. You can safely ignore this parameter.
applicationNameStringThe unique identifier assigned to each app by the Chat service .
uriStringThe request URI.
pathStringThe request path, which is part of the request URL. You can safely ignore this parameter.
entities JSON ArrayThe response entity.
entities.uuidStringThe user's UUID. A unique internal identifier generated by the Chat service for the user in this request. This is used for generating the user token.
entities.typeStringThe type of the object. You can safely ignore this parameter.
entities.createdNumberThe Unix timestamp (ms) when the user is registered.
entities.modifiedNumberThe Unix timestamp (ms) when the user information is last modified.
entities.usernameStringThe username. The unique account the user is logged in with.
entities.activatedBoolWhether the user is active: true: The user is active. false: The user is banned. To use a banned user account, you need to call the unban-user method to unban the account.
timestampNumberThe Unix timestamp (ms) of the HTTP response.
durationNumberThe duration (ms) from when the HTTP request is sent to the time the response is received.

Authorization

Chat RESTful APIs require Bearer HTTP authentication. Every time an HTTP request is sent, the following Authorization field must be filled in the request header:

Authorization: Bearer ${YourAppToken}

In order to improve the security of the project, Agora uses a token (dynamic key) to authenticate users before they log in to the chat system. Chat RESTful APIs only support authenticating users using app tokens. For details, see Authentication using App Token.

Registering a user

This method creates a user account.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

POST https://{host}/app-id/{app_id}/users

Path parameter

For the parameters and detailed descriptions, see Common parameters.

Request header

ParameterTypeDescriptionRequired
Content-TypeStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

Request body

The request body is a JSON object, which contains the following fields:

FieldTypeDescriptionRequired
usernameStringThe unique login account of the user. The username must be 64 bytes or less and cannot be empty.Yes

HTTP response

Response body

If the returned HTTP status code is 200, the request succeeds. For fields and detailed descriptions, see Common parameters.

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token generated in your server.
curl -X POST -H 'Content-Type: application/json' -H 'Accept: application/json' -H 'Authorization:Bearer {YourAppToken}' -i "https://XXXX/app-id/XXXX/users" -d '
    {
      "username": "user1"
    }'

Response example

{
    "action": "post",
    "application": "8be024f0-XXXX-XXXX-b697-5d598d5f8402",
    "path": "/users",
    "uri": "https://a1.agora.com/XXXX/XXXX/users",
    "entities": [
        {
            "uuid": "0ffe2d80-XXXX-XXXX-8d66-279e3e1c214b",
            "type": "user",
            "created": 1542795196504,
            "modified": 1542795196504,
            "username": "user1",
            "activated": true,
        }
    ],
    "timestamp": 1542795196515,
    "duration": 0,
    "organization": "XXXX",
    "applicationName": "XXXX"
}

Registering multiple users

This method registers multiple users within one request. You can pass a maximum of 60 user IDs in a single request.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

POST https://{host}/app-id/{app_id}/users

Path parameter

For the parameters and detailed descriptions, see Common parameters .

Request header

ParameterTypeDescription
Content-TypeStringapplication/json
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.

Request body

The request body is a JSONArray object, which contains the following fields:

FieldTypeDescriptionRequired
usernameStringThe unique user ID of the user. The user ID must be 64 characters or less and cannot be empty. You can pass in at most 60 user IDs.Yes

HTTP response

Response body

If the returned HTTP status code is 200, the request succeeds, and the response body contains the following fields:

FieldTypeDescription
dataJSONArrayThe details of the response. In this data array, the username and reason for the registration failure are displayed.

For other fields and detailed descriptions, see Common parameters.

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example 1

Registering 2 users:

# Replace {YourAppToken} with the app token generated in your server.
curl -X POST -H 'Content-Type: application/json' -H 'Authorization:Bearer {YourAppToken}' -i "https://XXXX/app-id/XXXX/users" -d '[
    {
        "username":"user1"
    },
    {
        "username":"user2"
    }
]'

Response example 1

{
    "action": "post",
    "application": "22bcffa0-XXXX-XXXX-9df8-516f6df68c6d",
    "path": "/users",
    "uri": "https://XXXX/app-id/XXXX/users",
    "entities": [
        {
            "uuid": "278b5e60-XXXX-XXXX-8f9b-d5d83ebec806",
            "type": "user",
            "created": 1541587920710,
            "modified": 1541587920710,
            "username": "user1",
            "activated": true,
        },
        {
            "uuid": "278bac80-XXXX-XXXX-b192-73e4cd5078a5",
            "type": "user",
            "created": 1541587920712,
            "modified": 1541587920712,
            "username": "user2",
            "activated": true,
        }
    ],
    "timestamp": 1541587920714,
    "data": [],
    "duration": 0,
    "organization": "XXXX",
    "applicationName": "XXXX"
}

Request example 2

If the request body contains a user3 that has previously been registered, the registration of user3 fails while those of user1 and user2 succeed. The failure is reported in the data array of the response body.

# Replace {YourAppToken} with the app token generated in your server.
curl -X POST -H 'Content-Type: application/json' -H 'Authorization:Bearer {YourAppToken}' -i "https://XXXX/app-id/XXXX/users" -d '[
    {
        "username":"user1"
    },
    {
        "username":"user2"
    },
    {
        "username":"user3"
    }
]'

Response example 2

{
    "action": "post",
    "application": "22bcffa0-XXXX-XXXX-9df8-516f6df68c6d",
    "path": "/users",
    "uri": "https://XXXX/app-id/XXXX/users",
    "entities": [
        {
            "uuid": "278b5e60-XXXX-XXXX-8f9b-d5d83ebec806",
            "type": "user",
            "created": 1541587920710,
            "modified": 1541587920710,
            "username": "user1",
            "activated": true,
        },
        {
            "uuid": "278bac80-XXXX-XXXX-b192-73e4cd5078a5",
            "type": "user",
            "created": 1541587920712,
            "modified": 1541587920712,
            "username": "user2",
            "activated": true,
        }
    ],
    "timestamp": 1541587920714,
    "data": [
        {
            "username": "user3",
            "registerUserFailReason": "the user3 already exists"
        }
    ],
    "duration": 0,
    "organization": "XXXX",
    "applicationName": "XXXX"
}

Querying a user

This method queries the detailed information of the specified user.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

GET https://{host}/app-id/{app_id}/users/{username}

Path parameter

For the parameters and detailed descriptions, see Common parameters.

Request header

ParameterTypeDescriptionRequired
AcceptStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

HTTP response

Response body

If the returned HTTP status code is 200, the request succeeds, and the response body contains the following fields:

FieldTypeDescription
countNumberThe number of users.

For other fields and detailed descriptions, see Common parameters.

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token generated in your server.
curl -X GET -H 'Accept: application/json' -H 'Authorization: Bearer {YourAppToken}' 'http://XXXX/app-id/XXXX/users/XXXX'

Response example

{
    "action": "get",
    "path": "/users",
    "uri": "http://XXXX/app-id/XXXX/users/XXXX",
    "entities": [
        {
            "uuid": "0ffe2d80-XXXX-XXXX-8d66-279e3e1c214b",
            "type": "user",
            "created": 1542795196504,
            "modified": 1542795196504,
            "username": "XXXX",
            "activated": true,
            "nickname": "testuser"
        }
    ],
    "timestamp": 1542798985011,
    "duration": 1,
    "count": 1
}

Querying multiple users

This method queries the information of multiple users in ascending order of their registration time.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

GET https://{host}/app-id/{app_id}/users?limit={N}&{cursor}

Path parameter

For the parameters and detailed descriptions, see Common parameters.

Query parameters

ParameterTypeDescriptionRequired
limitNumberThe number of users whose information you want to query. The default value is 10, and the value range is [1,100]. The user list is displayed in ascending order of their registration time by default.No
cursorStringThe cursor used for paginating the user lists. You do not need to set cursor at the first query. When the request succeeds, you can get the user list on the first page. You can also get the cursor from the response body, and pass the cursor in the URL of the next request, until there is no longer a cursor field in the response body, which means that all the users in the app have been queried.No

Request header

ParameterTypeDescriptionRequired
AcceptStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

HTTP response

Response body

If the returned HTTP status code is 200, the request succeeds, and the response body contains the following fields:

ParameterTypeDescription
cursorStringThe cursor used for paginating the user lists. You do not need to set cursor at the first query. When the request succeeds, you can get the cursor from the response body, and pass this cursor in the URL of the next query, until there is no longer a cursor field in the response body, which indicates that all the users in the app have been queried.
countNumberThe number of users.

For other fields and detailed descriptions, see Common parameters.

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example 1

Querying the information list of two users in ascending order of their registration time:

# Replace {YourAppToken} with the app token generated in your server.
curl -X GET -H 'Accept: application/json' -H 'Authorization: Bearer {YourAppToken}' 'http://XXXX/app-id/XXXX/users?limit=2'

Response example 1

Return the information list of the 2 users:

{
    "action": "get",
    "params": {
        "limit": ["2"]
    },
    "path": "/users",
    "uri": "http://XXXX/app-id/XXXX/users",
    "entities": [
        {
            "uuid": "ab90eff0-XXXX-XXXX-9174-8f161649a182",
            "type": "user",
            "created": 1542356511855,
            "modified": 1542356511855,
            "username": "XXXX",
            "activated": true,
            "nickname": "testuser1"
        },
        {
            "uuid": "b2aade90-XXXX-XXXX-a974-f3368f82e4f1",
            "type": "user",
            "created": 1542356523769,
            "modified": 1542356523769,
            "username": "user2",
            "activated": true,
            "nickname": "testuser2"
        }
    ],
    "timestamp": 1542558467056,
    "duration": 1,
    "cursor": "LTgzNDAxMjM3OToxTEFnNE9sNEVlaVQ0UEdhdmJNR2tB",
    "count": 2
}

Request example 2

Use the cursor in response example 1 to query the user list on the next page in ascending order of their registration time. The number of users on this page is two:

# Replace {YourAppToken} with the app token generated in your server.
curl -X GET -H 'Accept: application/json' -H 'Authorization: Bearer {YourAppToken}' 'http://XXXX/app-id/XXXX/users?limit=2&cursor=LTgzNDAxMjM3OToxTEFnNE9sNEVlaVQ0UEdhdmJNR2tB'

Response example 2

Continue to return a list of information for two users:

{
    "action": "get",
    "params": {
        "cursor": ["LTgzNDAxMjM3OToxTEFnNE9sNEVlaVQ0UEdhdmJNR2tB"],
        "limit": ["2"]
    },
    "path": "/users",
    "uri": "http://XXXX/app-id/XXXX/users",
    "entities": [
        {
            "uuid": "fef7f250-XXXX-XXXX-ba39-0fed7dcc3cdd",
            "type": "user",
            "created": 1542361376245,
            "modified": 1542361376245,
            "username": "XXXX",
            "activated": true,
            "nickname": "testuser3"
        },
        {
            "uuid": "gufhj730-XXXX-XXXX-bc68-d8ij7dc3uyac",
            "type": "user",
            "created": 1542361376978,
            "modified": 1542361376978,
            "username": "XXXX",
            "activated": true,
            "nickname": "testuser4"
        }
    ],
    "timestamp": 1542559337702,
    "duration": 2,
    "count": 2
}

Deleting a user

This method deletes the specified user. If the deleted user is the admin of a group or chat room, the group or chat room they manage is also deleted.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

DELETE https://{host}/app-id/{app_id}/users/{username}

Path parameter

For the parameters and detailed descriptions, see Common parameters.

Request header

ParameterTypeDescriptionRequired
AcceptStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

HTTP response

Response body

If the returned HTTP status code is 200, the request succeeds. For fields and descriptions of the response body, see Common parameters.

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token generated in your server.
curl -X DELETE -H 'Accept: application/json' -H 'Authorization: Bearer {YourAppToken}' 'http://XXXX/app-id/XXXX/users/user1'

Response example

{
    "action": "delete",
    "applicationName": "XXXX"
    "path": "/users",
    "uri": "https://XXXX/app-id/XXXX/users",
    "entities": [
        {
            "uuid": "ab90eff0-XXXX-XXXX-9174-8f161649a182",
            "type": "user",
            "created": 1542356511855,
            "modified": 1542356511855,
            "username": "XXXX",
            "activated": true,
            "nickname": "user1"
        }
    ],
    "timestamp": 1542559539776,
    "duration": 39,
    "organization": "XXXX",
    "applicationName": "XXXX"
}

Deleting multiple users

This method deletes multiple users in the app in the chronological order of their creation. For the first request, the API deletes users, starting from the first created one. A maximum of 100 users can be deleted each time. It should be noted that this method specifies the number of users to delete, instead of which users to delete.

If the deleted users include group or chat room admins, the groups and chat rooms managed by those users are also deleted.

For each App Key, the call frequency limit of this method is 30 per second.

HTTP request

DELETE https://{host}/app-id/{app_id}/users?limit={N}&cursor={cursor}

Path parameter

For the parameters and detailed descriptions, see Common parameters.

Query parameter

ParameterTypeDescriptionRequired
limitNumberThe number of users to delete. The value range is [1,100] with 10 as the default.No
cursorStringThe position where to start deleting users. No cursor is required for the first request. For each subsequent request, the cursor is obtained from the body of response to the previous request. If the cursor is no longer returned, all users are deleted.No

Request header

ParameterTypeDescriptionRequired
AcceptStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

HTTP response

Response body

If the returned HTTP status code is 200, the request is successful. For fields and descriptions of the response body, see Public parameter.

If the returned HTTP status code is not 200, the request fails. You can refer to the Status code for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token generated in your server.
curl -X DELETE -H 'Accept: application/json' -H 'Authorization: Bearer ' 'https://XXXX/app-id/XXXX/users?limit=2'

Response example

{
  "action": "delete",
  "application": "8be024f0-XXXX-XXXX-b697-5d598d5f8402",
  "params": {
    "limit": ["2"]
  },
  "path": "/users",
  "uri": "https://XXXX/XXXX/testapp/users",
  "entities": [
    {
      "uuid": "b2aade90-XXXX-XXXX-a974-f3368f82e4f1",
      "type": "user",
      "created": 1542356523769,
      "modified": 1542597334500,
      "username": "user2",
      "activated": true,
      "nickname": "testuser"
    },
    {
      "uuid": "b98ad170-XXXX-XXXX-XXXX-7f76daa76557",
      "type": "user",
      "created": 1542356535303,
      "modified": 1542356535303,
      "username": "user3",
      "activated": true,
      "nickname": "user3"
    }
  ],
  "timestamp": 1542867197779,
  "duration": 504,
  "organization": "XXXX",
  "applicationName": "testapp",
  "cursor": "LTgXXXXDNR"
}

Modifying the password

This method modifies the user password. You do not need to provide the original password.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

PUT https://{host}/app-id/{app_id}/users/{username}/password

Path parameter

For the parameters and detailed descriptions, see Common parameters.

Request header

ParameterTypeDescriptionRequired
Content-TypeStringapplication/jsonYes
AcceptStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

Request body

The request body is a JSON object, which contains the following fields:

FieldTypeDescriptionRequired
newpasswordStringThe new user login password. The length cannot exceed 64 bytes.Yes

For other fields and detailed descriptions, see Common parameters.

HTTP response

Response body

If the returned HTTP status code is 200, the request succeeds. For fields and descriptions of the response body, see Common parametes.

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token you generated on the server, and {YourPassword} with the new password you set
curl -X PUT -H 'Content-Type: application/json' -H 'Accept: application/json' -H 'Authorization: Bearer {YourAppToken}' -d '{ "newpassword": "{YourPassword}" }' ' http://XXXX/app-id/XXXX/users/user1/password'

Response example

{
    "action": "set user password",
    "timestamp": 1542595598924,
    "duration": 8
}

Banning a user

This method disables a user account. The user goes offline immediately and is not able to log in until the ban is lifted.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

POST https://{host}/app-id/{app_id}/users/{username}/deactivate

Path parameter

For the parameters and detailed descriptions, see Common parameters.

Request header

ParameterTypeDescriptionRequired
Content-TypeStringapplication/jsonYes
AcceptStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

HTTP response

Response body

If the returned HTTP status code is 200, the request is succeeds and the response body contains the following fields:

For fields and detailed descriptions, see Common parameters.

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token generated in your server.
curl -X POST -H 'Content-Type: application/json' -H 'Accept: application/json' -H 'Authorization: Bearer {YourAppToken}' 'http://XXXX/app-id/XXXX/users/user1/deactivate'

Response example

{
    "action": "Deactivate user",
    "entities": [
        {
            "uuid": "4759aa70-XXXX-XXXX-925f-6fa0510823ba",
            "type": "user",
            "created": 1542595573399,
            "modified": 1542597578147,
            "username": "XXXX",
            "activated": false,
            "nickname": "user"
        }
    ],
    "timestamp": 1542602157258,
    "duration": 12
}

Unbanning a user

This method unbans a deactivated user account. After the ban is lifted, the user can log in to Chat.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

POST https://{host}/app-id/{app_id}/users/{username}/activate

Path parameter

For the parameters and detailed descriptions, see Common parameters.

Request header

ParameterTypeDescriptionRequired
Content-TypeStringapplication/jsonYes
AcceptStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

HTTP response

Response body

If the returned HTTP status code is 200, the request succeeds, and the response body contains the following fields:

For fields and detailed descriptions, see Common parameters.

For other fields and detailed descriptions, see Common parameters. If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token generated in your server.
curl -X POST -H 'Content-Type: application/json' -H 'Accept: application/json' -H 'Authorization: Bearer {YourAppToken}' 'http://XXXX/app-id/XXXX/users/user1/activate'

Response example

{
    "action": "activate user",
    "timestamp": 1542602404132,
    "duration": 9
}

Forcing a user offline

This method forcibly moves a user offline. The offline user must log in again to use the Chat service.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

GET https://{host}/app-id/{app_id}/users/{username}/disconnect

Path parameter

For the parameters and detailed descriptions, see Common parameters.

Request header

ParameterTypeDescriptionRequired
Content-TypeStringapplication/jsonYes
AcceptStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

HTTP response

Response body

If the returned HTTP status code is 200, the request succeeds, and the response body contains the following fields:

FieldTypeDescription
dataJSONThe details of the response.
data.resultBoolThe logout result, only displayed as true, which indicates that the user has been forced offline.

For other fields and detailed descriptions, see Common parameters.

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token generated in your server.
curl -X GET -H 'Accept: application/json' -H 'Authorization: Bearer {YourAppToken}' 'http://XXXX/app-id/XXXX/users/XXXX/disconnect'

Response example

{
    "uri": "http://XXXX/app-id/XXXX/users/XXXX/disconnect",
    "timestamp": 1642053735842,
    "organization": "1122161011178276",
    "application": "22bcffa0-XXXX-XXXX-9df8-516f6df68c6d",
    "entities": [],
    "action": "get",
    "data": {
        "result": true
    },
    "duration": 0,
    "applicationName": "XXXX"
}

Querying the online state of a user

This method queries whether a user is online.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

GET https://{host}/app-id/{app_id}/users/{username}/status

Path parameter

For the parameters and detailed descriptions, see Common parameters.

Request header

ParameterTypeDescriptionRequired
Content-TypeStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

HTTP response

Response body

If the returned HTTP status code is 200, the request succeeds, and the response body contains the following fields:

ParameterTypeDescription
dataJSONThe online state of a user, in the format of "username": "online state". For example, if user1 is online, returns "user1": "online"; otherwise, returns "user1": "offline".

For the parameters and detailed descriptions, see Common parameters.

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token generated in your server.
curl -X GET -H 'Accept: application/json' -H 'Authorization: Bearer {YourAppToken}' 'http://XXXX/app-id/XXXX/users/user1/status'

Response example

{
    "action": "get",
    "uri": "http://XXXX/app-id/XXXX/users/user1/status",
    "entities": [],
    "data": {
        "user1": "offline"
    },
    "timestamp": 1542601284531,
    "duration": 4,
    "count": 0
}

Querying the online state of multiple users

This method queries whether multiple users are online.

For each App Key, the call frequency limit of this method is 50 per second.

HTTP request

POST https://{host}/app-id/{app_id}/users/batch/status

Path parameter

For the parameters and detailed descriptions, see Common parameters.

Request header

ParameterTypeDescriptionRequired
Content-TypeStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

Request body

ParameterTypeDescription
usernamesArrayThe users whose online state you want to query. You can specify a maximum of 100 usernames at the same time.

HTTP response

Response body

If the returned HTTP status code is 200, the request succeeds, and the response body contains the following fields:

ParameterTypeDescription
dataJSONThe online state of a user, in the format of "username": "online state". For example, if user1 is online, returns "user1": "online"; otherwise, returns "user1": "offline".

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token generated in your server.
curl -X POST http://XXXX/app-id/XXXX/users/batch/status -H 'Authorization: Bearer {YourAppToken}' -H 'Content-Type: application/json' -d '{"usernames":["user1","user2"]}'

Response example

This API does not check whether the specified usernames are valid. If the specified username does not exist, the state of this user is reported as offline.

{
  "action": "get batch user status",
  "data": [
    {
      "user1": "offline"
      },
    {
      "user2": "offline"
      }
    ],
  "timestamp": 1552280231926,
  "duration": 4
}

Querying the number of offline messages

This method queries the number of offline messages a user has, and whether or not they have been delivered.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

GET https://{host}/app-id/{app_id}/users/{owner_username}/offline_msg_count

Path parameter

ParameterTypeRequiredDescription
owner_usernameStringYesThe users whose number of offline messages you want to query.

For the parameters and detailed descriptions, see Common parameters.

Request header

ParameterTypeDescriptionRequired
Content-TypeStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

HTTP response

Request body

If the returned HTTP status code is 200, the request succeeds, and the response body contains the following fields:

ParameterTypeDescription
dataJSONThe number of offline messages a user has, regardless of the delivery state, in the format of "username": "number of offline messages". For example, if user1 does not have offline messages, returns "user1": "0".

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token generated in your server.
curl -X GET -H 'Accept: application/json' -H 'Authorization: Bearer {YourAppToken}' 'http://XXXX/app-id/XXXX/users/user1/offline_msg_count'

Response example

{
  "action": "get",
  "uri": "http://XXXX/XXX/XXXX/users/XXX/offline_msg_count",
  "entities": [],
  "data": {
    "user1": 0
  },
  "timestamp": 1542601518137,
  "duration": 3,
  "count": 0
}

Querying the delivery state of an offline message

This method queries the delivery state of an offline message.

For each App Key, the call frequency limit of this method is 100 per second.

HTTP request

GET https://{host}/app-id/{app_id}/users/{username}/offline_msg_status/{msg_id}

Path parameter

ParameterTypeRequiredDescription
usernameStringYesThe user whose offline message's delivery states you want to query.
msg_idStringYesThe message of which you want to query the delivery state.

For the parameters and detailed descriptions, see Common parameters.

Request header

ParameterTypeDescriptionRequired
Content-TypeStringapplication/jsonYes
AuthorizationStringThe authentication token of the user or admin, in the format of Bearer ${YourAppToken}, where Bearer is a fixed character, followed by an English space, and then the obtained token value.Yes

HTTP response

Response body

If the returned HTTP status code is 200, the request succeeds, and the response body contains the following fields:

ParameterTypeDescription
dataJSONThe delivery state of an offline message, in the format of "message id": "delivery state". The delivery state: delivered: The offline message has been delivered to the user. undelivered: The offline message is temporarily stored at the server and has not been pulled from the server and delivered to the user.

If the returned HTTP status code is not 200, the request fails. You can refer to Status codes for possible reasons.

Example

Request example

# Replace {YourAppToken} with the app token generated in your server.
curl -X GET -H 'Accept: application/json' -H 'Authorization: Bearer {YourAppToken}' 'http://XXXX/app-id/XXXX/users/user1/offline_msg_status/123'

Response example

{
    "action": "get",
    "uri": "http://XXXX/app-id/XXXX/users/user1/offline_msg_status/123",
    "entities": [],
    "data": {
        "123": "delivered"
    },
    "timestamp": 1542601830084,
    "duration": 5,
    "count": 0
}

Status codes

For details, see HTTP Status Codes.